""" RestrictedDEQueue - double-ended queue 
holding a restricted type """
from DEQueueDecorator import DEQueueDecorator
class RestrictedDEQueue(DEQueueDecorator):
	"Base class for decorators of double-ended queues"
	def __init__(self,type,dequeue): #dequeue=None
		#if not dequeue:
		#	dequeue=DEQueue.DEQueue()
		DEQueueDecorator.__init__(self,dequeue)
		self.requiredType=type
	def checkType(self,x):
		if not isinstance(x,self.requiredType):
			raise TypeError(str(type(x))+ \
			   " not "+str(self.requiredType))
		return
	def put(self,x):
		"Put at end of a DEQueue: q.put(x)"
		self.checkType(x)
		DEQueueDecorator.put(self,x)
	def push(self,x):
		"Push at front of a DEQueue: q.push(x)"
		self.checkType(x)
		DEQueueDecorator.push(self,x)
	def copy(self):
		"Copy of a DEQueueue: q.copy()"
		return RestrictedDEQueue(self.requiredType, \
			self.rep.copy())
	def __repr__(self):
		return "RestrictedDEQueue("+ \
			str(self.requiredType) \
			+","+repr(self.rep)+")"

