import types

class NonSplitter:
	def __init__(self,src):
		self.src=src
		self._done=0
	def nextElement(self):
		if self._done:
			raise IndexError
		self._done=1
		return self.src
	def hasMoreElements(self):
		return not self._done
	
class Splitter:
	def __init__(self,sep,src):
		self.sep=sep
		self.sepTuple=(sep,)
		if type(src) is types.StringType or \
		   type(src) is types.UnicodeType:
		 	self.src=NonSplitter(src)
		else:
			self.src=src
		self.buf=''
		self.state=_getNext
	def hasMoreElements(self):
		return self.state.hasMoreElements(self)
	def nextElement(self):
		return self.state.nextElement(self)

def Splitters(seps,src):
	for x in seps:
		src=Splitter(x,src)
	return src

class _StringNextState:
	#here if splitter.buf contains more string to split
	def nextElement(self,splitter):
		if len(splitter.buf)==0:
			splitter.state=_getNext
			return _getNext.nextElement(splitter)
		x=splitter.buf.split(splitter.sep,1)
		if len(x)==1:
			splitter.state=_getNext
			return x[0]
		else:
			splitter.buf=x[1]
			if x[0]=='':
				#splitter.state remains _StringNextState
				return splitter.sepTuple
			else:
				splitter.state=_sepNext
				return x[0]
			
	def hasMoreElements(self,splitter):
		if len(splitter.buf)>0:
			return 1
		else:
			return splitter.src.hasMoreElements()
_stringNext=_StringNextState()
class _SepNextState:
	#here if splitter.sep is next string to return
	def nextElement(self,splitter):
		splitter.state=_stringNext
		return splitter.sepTuple
	def hasMoreElements(self,splitter):
		return 1
_sepNext=_SepNextState()
class _GetNextState:
	#here if splitter.buf is exhausted, read from splitter.src
	def nextElement(self,splitter):
		splitter.buf=splitter.src.nextElement()
		if type(splitter.buf) is types.TupleType:
			#state remains _GetNextState
			return splitter.buf
		splitter.state=_stringNext
		return splitter.state.nextElement(splitter)
	def hasMoreElements(self,splitter):
		x=splitter.src.hasMoreElements()
		if not x:
			splitter.state=_done
		return x
_getNext=_GetNextState()
class _DoneState:
	#here if nothing more to return
	def nextElement(self,splitter):
		raise IndexError
	def hasMoreElements(self,splitter):
		return 0
_done=_DoneState()
