"""
Uniform random deviate generator

X[n+1] = a*X[n] % m
where
a = 48271
m = 2**31-1
arithmetic is performed such that overflow will not occur.
"""
#define A 16807
#define M 2147483647
#define Q 127773
#define R 2836
#define AA 48271
#define QQ 44488
#define RR 3399
#define AAA 69621
#define QQQ 30845
#define RRR 23902
M=2147483647
class compose:
	def __init__(self,f,g):
		self.f=f
		self.g=g
	def __call__(self,*x):
		return self.f(self.g(*x))
class hasher:
	def __init__(self,A,Q,R):
		self.A=A
		self.Q=Q
		self.R=R
	def __call__(self,s):
		if s<=0: s=M+s
		if s==0 or s==M: s=self.A+self.Q+self.R #just something
		hi = s / self.Q
		lo = s % self.Q
		test = self.A * lo - self.R * hi
		if (test > 0):
			s = test
		else:
			s = test + M
		return s
hash1=hasher(16807,127773,2836)
hash2=hasher(48271,44488,3399)
hash3=hasher(69621,30845,23902)
hash12=compose(hash1,hash2)
hash23=compose(hash2,hash3)
hash31=compose(hash3,hash1)

