#LLk parser tokens
import Token
import toolsofcomputing_org.adt.DEQueue as DEQueue
import Semantics
import types
import sys

class ActionSemantics(Semantics.Semantics):
	def __init__(self):
		self.__semStk=DEQueue.DEQueue()

	def outToken(self,t):
		self.__semStk.push(t)


	def outError(self,t):
		self.__semStk.push(t)

	def outAction(self,t):
		f,n=self.actionRoutineInfo(t)
		L=[] #was [self]
		for i in range(n):
			L.insert(0,self.__semStk.pop())
		try:
			x=apply(f,L)
		except:
			cl,exc,tb=sys.exc_info()
			x=Token.mkErrorToken(str(cl),str(exc))
		self.__semStk.push(x)

	def close(self):
		self.__semStk.pop() #the EOI
		return self.__semStk.pop()

	def actionRoutineInfo(self,t):
		m=getattr(self,t)
		if isinstance(m,types.MethodType):
			f=m.im_func
			n=f.func_code.co_argcount-1
		elif isinstance(m,types.FunctionType):
			f=m
			n=f.func_code.co_argcount
		elif isinstance(m,types.ClassType):
			try:
				f=m.__init__.im_func
				n=f.func_code.co_argcount-1
			except:
				n=0
		elif isinstance(m,types.InstanceType):
			try:
				f=m.__call__.im_func
				n=f.func_code.co_argcount-1
			except:
				n=0
		else:
			raise TypeError("action "+t+" not callable")
		return m,n	
