
class Token:
	def __init__(self,type,body="",line=0, \
			column=0,source=None):
		self.type=type
		self.body=body
		self.line=line
		self.column=column
		self.source=source
	def __repr__(self):
		return "Token("+repr(self.type)+","+ \
			repr(self.body)+","+ \
			repr(self.line)+","+ \
			repr(self.column)+","+ \
			repr(self.source)+")"
	def __str__(self): return repr(self)
	def recycle(self):recycle(self)
	def copy(self):
		return makeForClass[self.__class__] \
			(self.type,self.body, \
			self.line,self.column,self.source)

class ErrorToken(Token):
	def __repr__(self):
		return "Error"+Token.__repr__(self)

class ActionToken(Token):
	def __repr__(self):
		return "Action"+Token.__repr__(self)

TokenPool=[]
ErrorTokenPool=[]
ActionTokenPool=[]
pools={Token:TokenPool, \
	ErrorToken:ErrorTokenPool, \
	ActionToken:ActionTokenPool}
def mkToken(*args):
	if TokenPool: 
		t=TokenPool.pop()
		t.__init__(*args)
	else:	t=Token(*args)
	return t
def mkErrorToken(*args):
	if ErrorTokenPool: 
		t=ErrorTokenPool.pop()
		t.__init__(*args)
	else:	t=ErrorToken(*args)
	return t
def mkActionToken(*args):
	if ActionTokenPool: 
		t=ActionTokenPool.pop()
		t.__init__(*args)
	else:	t=ActionToken(*args)
	return t
def recycle(*tokens):
	for t in tokens:
		pools[t.__class__].append(t)

makeForClass={Token:mkToken,ErrorToken:mkErrorToken, \
	ActionToken:mkActionToken}

