import threading

class StateError(StandardError):pass

class Future:
	def __init__(self,*arg):
		self.lock=threading.RLock()
		self.full=threading.Condition(self.lock)
		if len(arg)>0:
			self.contents=arg[0]
	def isSet(self):
		self.lock.acquire()
		try:
			return hasattr(self,"contents")
		finally: 
			self.lock.release()
		
	def set(self,x):
		self.lock.acquire()
		try:
			if self.isSet():
				raise StateError("Future already set")
			self.contents=x
			self.full.notifyAll()
		finally: 
			self.lock.release()
	def get(self):
		self.lock.acquire()
		try:
			if not self.isSet():
				self.full.wait()
			return self.contents
		finally: 
			self.lock.release()

