from threading import *
import toolsofcomputing_org.adt.DEQueue as DEQueue
import sys

class TerminateException(Exception): pass

import traceback

def simpleRunStrategy(runnable,rq):
	runnable.run()

def Xeq(runQueue,runStrategy):
	while 1:
		try:
			r=runQueue.deq()
			runStrategy(r,runQueue)
		except TerminateException:
			runQueue.numThreads-=1
			return
		except:
			traceback.print_exc()

class RunQueue:
	def __init__(self,**kwargs):
		self.runStrategy=kwargs.get('runstrategy', \
			simpleRunStrategy)
		self.maxThreads=kwargs.get('maxthreads', \
			sys.maxint)
		self.numThreads=0
		self.numThreadsWaiting=0
		self.rq=kwargs.get('queue')
		if self.rq is None: self.rq=DEQueue.DEQueue()
		self.lock=RLock()
		self.awaitWork=Condition(self.lock)
		self.stop=0
		self.makeDaemon=1
		self.threadfunction=kwargs.get( \
			'threadfunction',Xeq)
	def enq(self,*r):
		self.lock.acquire()
		self.rq.put(*r)
		if self.numThreadsWaiting>0:
			self.numThreadsWaiting-=1
			self.awaitWork.notify()
		elif self.numThreads<self.maxThreads:
			t=Thread(target=self.threadfunction, \
				args=(self,self.runStrategy))
			t.setDaemon(self.makeDaemon)
			self.numThreads+=1
			t.start()
		self.lock.release()
	put=run=enq
	def deq(self):
		self.lock.acquire()
		while len(self.rq)==0:
			if self.stop:
				self.numThreads-=1 
				self.lock.release()
				raise TerminateException
			self.numThreadsWaiting+=1
			self.awaitWork.wait()
		if self.stop: 
			self.numThreads-=1 
			self.lock.release()
			raise TerminateException
		r=self.rq.get()
		self.lock.release()
		return r
	get=deq
	def terminate(self):
		self.lock.acquire()
		self.stop=1
		self.awaitWork.notifyAll()
		self.numThreadsWaiting=0
		self.lock.release()
			