from threading import *

class _folder:
	def __init__(self):
		self.q=[]
		self.await=Condition()
		self.numInterested=1
	def put(self,x):
		self.await.acquire()
		self.q.append(x)
		self.await.notify()
		self.await.release()
	def get(self):
		self.await.acquire()
		if len(self.q)==0: self.await.wait()
		x=self.q.pop(0)		
		self.await.release()
		return x
	def get_skip(self):
		self.await.acquire()
		if len(self.q)>0:
			x=self.q.pop(0)
		else:
			x=None		
		self.await.release()
		return x

class SharedTableOfQueues:
	def __init__(self):
		self.tbl={}
		self.lock=Lock()
	def _seizeFolder(self,key):
		self.lock.acquire()
		f=self.tbl.get(key)
		if f==None:
			f=self.tbl[key]=_folder()
		self.lock.release()
		return f
	def _releaseFolder(self,key,f):
		self.lock.acquire()
		f.numInterested-=1
		if f.numInterested==0 and len(f.q)==0:
			del self.tbl[key]
		self.lock.release()
	def put(self,key,x):
		#print "put",key,x
		f=self._seizeFolder(key)
		f.put(x)
		f=self._releaseFolder(key,f)
	def get(self,key): 
		f=self._seizeFolder(key)
		x=f.get()
		f=self._releaseFolder(key,f)
		#print "get",key,x
		return x
	def get_skip(self,key): 
		f=self._seizeFolder(key)
		x=f.get_skip()
		#f=self._releaseFolder(key,f)
		#print "get_skip",key,x
		return x


