''' Dining Philosophers problem synchronizing through
a SharedDB. '''
import threading
import toolsofcomputing_org.threads.SharedDB as SharedDB
import random

numPhilosophers=7
iterations=50
timer=threading.Condition()
forks=SharedDB.SharedDB({})
d=forks.open()
for i in range(numPhilosophers):
	d['fork%d' % i] = -1
d.close()
state=['.']*numPhilosophers

def showState():
	#print reduce(lambda x,y: x+y,state)
	print "".join(state)

def delay(t):
	timer.acquire()
	timer.wait(t)
	timer.release()


class Philosopher(threading.Thread):
	def __init__(self,num):
		self.num=num
		threading.Thread.__init__(self)
	def run(self):
		leftFork='fork%d' % self.num
		rightFork='fork%d' % ((self.num+1)%numPhilosophers)
		for iternum in xrange(iterations):
			#get forks
			while 1:
				d=forks.open()
				try:
					left=d[leftFork]
					right=d[rightFork]
					delay(random.random())
					if left == right == -1:
						d[leftFork]=d[rightFork]=self.num
						d.close()
						break
					d.close()
				except SharedDB.CommitError:
					#print '('+str(self.num)+")"
					delay(random.random())
					pass
			state[self.num]=str(self.num); showState()
			delay(1*random.random())
			d=forks.open()
			d[leftFork] = d[rightFork] = -1
			state[self.num]='.'; showState()
			d.close()
def start():
	for i in range(numPhilosophers):
		p=Philosopher(i)
		p.start()

if __name__=='__main__':
	start()

