'''Dining Philosophers problem using a
Semaphore to limit the number of philosophers 
trying to eat at once to avoid deadlock.
'''
import threading
import toolsofcomputing_org.threads.SharedDB as SharedDB
import random
import sys

numPhilosophers=7
iterations=100
timer=threading.Condition()
forks=[None]*numPhilosophers
for i in range(numPhilosophers):
	forks[i] = threading.Lock()
state=['.']*numPhilosophers

eatingLimit=threading.Semaphore(numPhilosophers-1)

showlock=threading.Lock()
def showState():
	showlock.acquire()
	try:
		#print reduce(lambda x,y: x+y,state)
		s = "".join(state)
		print >>sys.stderr, s
		return s
	finally: showlock.release()

def delay(t):
	timer.acquire()
	timer.wait(t)
	timer.release()


class Philosopher(threading.Thread):
	def __init__(self,num):
		self.num=num
		threading.Thread.__init__(self)
	def run(self):
		leftFork= self.num
		rightFork= ((self.num+1)%numPhilosophers)
		for iternum in xrange(iterations):
			eatingLimit.acquire()
			state[self.num]='<'; showState()
			forks[leftFork].acquire()

			delay(1*random.random())

			state[self.num]='>'; showState()
			forks[rightFork].acquire()

			state[self.num]=str(self.num); showState()
			delay(2*random.random())

			state[self.num]='.'; showState()
			forks[rightFork].release()
			forks[leftFork].release()
			eatingLimit.release()
			delay(3*random.random())

def start():
	for i in range(numPhilosophers):
		p=Philosopher(i)
		p.start()

if __name__=='__main__':
	start()

